# Class Page

Page Class

#### Implements

- AbstractPage

- Defined in packages/saltcorn-data/models/page.ts:64

##### Index

### Constructors

constructor

### Properties

attributes?
description
fixed_states
id?
layout
min_role
name
title

### Accessors

html_file
menu_label

### Methods

clone
connected_objects
delete
getStringsForI18n
getTags
is_root_page_for_roles
run
create
find
findOne
renderEachEmbeddedPageInLayout
state_refresh
update

## Constructors

### constructor

- new Page(o: Page | PageCfg | PagePack): Page

  #### Parameters

  - o: Page | PageCfg | PagePack

  #### Returns Page

  - Defined in packages/saltcorn-data/models/page.ts:77

## Properties

### `Optional` attributes

attributes?: any

- Defined in packages/saltcorn-data/models/page.ts:72

### description

description: string

- Defined in packages/saltcorn-data/models/page.ts:67

### fixed_states

fixed_states: any

- Defined in packages/saltcorn-data/models/page.ts:71

### `Optional` id

id?: number

Implementation of AbstractPage.id

- Defined in packages/saltcorn-data/models/page.ts:68

### layout

layout: Layout

Implementation of AbstractPage.layout

- Defined in packages/saltcorn-data/models/page.ts:70

### min_role

min_role: number

Implementation of AbstractPage.min_role

- Defined in packages/saltcorn-data/models/page.ts:69

### name

name: string

Implementation of AbstractPage.name

- Defined in packages/saltcorn-data/models/page.ts:65

### title

title: string

- Defined in packages/saltcorn-data/models/page.ts:66

## Accessors

### html_file

- get html_file(): string | undefined

  #### Returns string | undefined

  - Defined in packages/saltcorn-data/models/page.ts:456

### menu_label

- get menu label for page

  #### Returns string | undefined

  - Defined in packages/saltcorn-data/models/page.ts:209

## Methods

### clone

- clone(): Promise<Page>

  Clone page

  #### Returns Promise<Page>

  - Defined in packages/saltcorn-data/models/page.ts:220

### connected_objects

- connected_objects(): ConnectedObjects

  #### Returns ConnectedObjects

  Implementation of AbstractPage.connected_objects

  - Defined in packages/saltcorn-data/models/page.ts:461

### delete

- delete(): Promise<void>

  Delete current page

  #### Returns Promise<void>

  - Defined in packages/saltcorn-data/models/page.ts:174

### getStringsForI18n

- getStringsForI18n(): string[]

  #### Returns string[]

  - Defined in packages/saltcorn-data/models/page.ts:152

### getTags

- getTags(): Promise<AbstractTag[]>

  #### Returns Promise<AbstractTag[]>

  Implementation of AbstractPage.getTags

  - Defined in packages/saltcorn-data/models/page.ts:465

### is_root_page_for_roles

- is_root_page_for_roles(): Promise<string[]>

  Is root page for role

  #### Returns Promise<string[]>

  - Defined in packages/saltcorn-data/models/page.ts:193

### run

- run(querystate: any, extraArgs: RunExtra): Promise<Layout | null>

  Run (Show) page

  #### Parameters

  - querystate: any
  - extraArgs: RunExtra

  #### Returns Promise<Layout | null>

  - Defined in packages/saltcorn-data/models/page.ts:241

### `Static` create

- create(f: PageCfg | PagePack): Promise<Page>

  Create page

  #### Parameters

  - f: PageCfg | PagePack

  #### Returns Promise<Page>

  - Defined in packages/saltcorn-data/models/page.ts:160

### `Static` find

- find(where?: Where, selectopts?: SelectOptions): Promise<Page[]>

  Find pages in DB

  #### Parameters

  - `Optional` where: Where
  - selectopts: SelectOptions = ...

  #### Returns Promise<Page[]>

  - Defined in packages/saltcorn-data/models/page.ts:99

### `Static` findOne

- findOne(where: Where): Page | null

  Find one page

  #### Parameters

  - where: Where

  #### Returns Page | null

  - Defined in packages/saltcorn-data/models/page.ts:118

### `Static` renderEachEmbeddedPageInLayout

- renderEachEmbeddedPageInLayout(
  layout: Layout,
  querystate: Row,
  extraArgs: RunExtra,
  ): Promise<void>

  #### Parameters

  - layout: Layout
  - querystate: Row
  - extraArgs: RunExtra

  #### Returns Promise<void>

  - Defined in packages/saltcorn-data/models/page.ts:470

### `Static` state_refresh

- state_refresh(): Promise<void>

  #### Returns Promise<void>

  - Defined in packages/saltcorn-data/models/page.ts:148

### `Static` update

- update(id: number, row: Row): Promise<void>

  Update page

  #### Parameters

  - id: number
  - row: Row

  #### Returns Promise<void>

  - Defined in packages/saltcorn-data/models/page.ts:142